﻿using AtmarkitReader.Data;

using System;
using System.Collections.Generic;
using Windows.UI.Xaml.Controls;

namespace AtmarkitReader
{
    // グループ項目を一覧表示し、その1つを選択するためのページ
    public sealed partial class ItemsPage : AtmarkitReader.Common.LayoutAwarePage
    {
        public ItemsPage()
        {
            this.InitializeComponent();
        }

        // OnNavigatedToメソッドから呼び出される。遷移後のページ生成を行う。
        // 【パラメータ】
        //  navigationParameter： フレームのNavigateメソッドで渡されたナビゲーション・パラメータ値。
        //  pageState： 前回のセッションでこのページにより保存された状態のディクショナリ。初回は当然、null。
        protected override async void LoadState(Object navigationParameter, Dictionary<String, Object> pageState)
        {
            // TODO: 以下のサンプル・データに置き換えて適切なデータ・モデルを作成する
            if (SampleDataSource.NeedAllFeeds)
            {
                await SampleDataSource.GetAllFeedsAsync();
            }
            var sampleDataGroups = SampleDataSource.GetGroups((String)navigationParameter);
            this.DefaultViewModel["Items"] = sampleDataGroups;
        }

        // グループ項目がクリックされたときに呼び出される。
        // 【パラメータ】
        // sender： クリックされたグループ項目を表示しているコントロール。
        // e： クリックされたグループ項目を説明するイベント・データ。
        void ItemView_ItemClick(object sender, ItemClickEventArgs e)
        {
            // クリックされたグループ項目の詳細ページ（Split Page）に遷移する。
            // このとき、必要な情報をナビゲーション・パラメータとして渡す
            var groupId = ((SampleDataGroup)e.ClickedItem).UniqueId;
            this.Frame.Navigate(typeof(SplitPage), groupId);
        }
    }
}
